
#
# 2014.10.20 jdwang@asia.edu.tw
#
# usage : perl PubMed_InfoExtration_14_ArticlesStatistics_DF_1.pl  "../SrcData_Topic_WilsonDisease_Parsed" "../SrcData_Topic_WilsonDisease_Statistics" "../stop-words/stop-words_english_3_en.txt"


use strict;
use Data::Dumper;
use jdwangPubMedPackage3;
use FileHandle;

my $SrcDataDir = $ARGV[0];
my $OutPutDir = $ARGV[1];
my $Stop_WordLocation = $ARGV[2];


my %StopWords = ();

my $fh_stopword = new FileHandle($Stop_WordLocation,"r") or die "can open $Stop_WordLocation";

while (my $OneStopWord  = <$fh_stopword> ) {
	
	chomp($OneStopWord);
	#print Dumper($OneStopWord);
	$StopWords{$OneStopWord}=0;
}
$fh_stopword->close();
#print Dumper(%StopWords);exit;



#
# 
#

my %ArticleWordsStatistics = ();

my @SegFileAry = ();
my $SeqFilesCnt = jdwangPubMedPackage3::DirFilenames($SrcDataDir,\@SegFileAry);
#print Dumper(@SegFileAry);exit;	
foreach my $OneFile (@SegFileAry) {
		my $InputFileLocation  = $SrcDataDir."/".$OneFile;		
		print "$InputFileLocation\n";		
			
		print "begin $OneFile ".scalar localtime(time())."\n";#exit;	
		
		my $fh_input = new FileHandle($InputFileLocation,"r");	
		
		
		my %OneArticleWordsStatistics = ();
		
		while (my $Line = <$fh_input>) {
			#25276143##2014-12-3##Fulminant Wilson's Disease Managed with Plasmapheresis as a Bridge to Liver Transplant.##New-onset jaundice can be a manifestation of multiple pathologic processes including hemolysis, parenchymal liver disease, and cholestasis; the differential diagnosis is broad and requires a systematic approach. We report a case of a patient who presented with jaundice after starting minocycline for the treatment of acne vulgaris and rapidly developed fulminant liver failure found to be due to Wilson's disease. She also manifested severe Coomb's negative hemolytic anemia and renal failure secondary to hepatorenal syndrome. As a bridge to liver transplant, she was successfully treated with plasmapheresis to decrease serum copper in addition to hemodialysis for acidosis and hyperkalemia. She was able to receive a liver and made a full recovery. The case highlights the use of plasmapheresis as an adjunctive treatment modality in cases of fulminant liver failure due to Wilson's disease.
			#print $Line; exit;
			chomp($Line);				
			
			my @Items = split (/\#\#/,$Line );
			#print Dumper(@Items);exit;
			my $PMID = $Items[0];
			my $Date = $Items[1];	
			my $Title = $Items[2];
			my $Abstract = $Items[3];
			
			my $Content = $Title." ".$Abstract;
			
			$Content  =~ s/\, |\. |\; |\.\x0D\x0A|\? |\: |\./\#/g;
	    
	    	#print Dumper($Content);exit;
	    
	    	my $SentenceSeparators = '#';
			
			my @Sentences = split ($SentenceSeparators,$Content);
									
			#print Dumper(@Sentence);exit;
			
			foreach my $OneSentence (@Sentences) {
				#print Dumper($OneSentence);
				if ($OneSentence ne '') {
					#print Dumper($OneSentence);exit;
					my @Words = split ( / /,$OneSentence);
				    #print Dumper(@Words);exit;
				    
				    # 
				    # record the term frequency (tf) of each "word"
				    #
				    
				    foreach my $OneWord (@Words) {
					    if (( $OneWord ne '')&&(! exists($StopWords{$OneWord}))) {
					   		$OneArticleWordsStatistics{$OneWord}++; 
				   		}
				    	#print Dumper(%ArticleWordsStatistics);exit; 
				    } # end of foreach my $OneWord (@Words)
				    #print Dumper(%ArticleWordsStatistics);exit;
				} else {
					# the sentence is empty
					#print Dumper($OneSentence);
				}# end of if ($OneSentence ne '')
			} # end of foreach $OneSentence (@Sentence)
			#print Dumper(%ArticleWordsStatistics);exit;
		} # end of while (my $Line = <$fh_input>)	
		$fh_input->close();	
		
		foreach my $OneWord (keys %OneArticleWordsStatistics) {
			$ArticleWordsStatistics{$OneWord}{'tf'} += $OneArticleWordsStatistics{$OneWord};
			$ArticleWordsStatistics{$OneWord}{'df'}++;	
		}	
		#print Dumper(%ArticleWordsStatistics);exit;	
		print "end $OneFile ".scalar localtime(time())."\n";
		#print Dumper(%ArticleStatistics);exit;		
} # end of foreach my $OneFile (@SegFileAry)
#print Dumper(%ArticleWordsStatistics);exit;

#
# output the term frequency (tf) of each word to file
# 
mkdir $OutPutDir;
my $OutputFileLocation = $OutPutDir."/"."ArticlesWordStatistics_13_9_RemoveStopWord_SortByWordTF_DF.txt";
#open(OutputFilehandle,">$OutputFileLocation ") or die "can't open $OutputFileLocation";
my $fh_output = new FileHandle($OutputFileLocation, "w" );
print $fh_output "Pattern\tTF\tDF\n";
foreach my $OneWord (sort {$ArticleWordsStatistics{$b} <=> $ArticleWordsStatistics{$a} } keys %ArticleWordsStatistics){	
	print "$OneWord\t$ArticleWordsStatistics{$OneWord}{'tf'}\t$ArticleWordsStatistics{$OneWord}{'df'}\n";
	print $fh_output "$OneWord\t$ArticleWordsStatistics{$OneWord}{'tf'}\t$ArticleWordsStatistics{$OneWord}{'df'}\n";
}
$fh_output->close;















